--- old/usr/src/tools/smatch/src/smatch_expressions.c	Tue Jan  7 08:01:55 2020
+++ new/usr/src/tools/smatch/src/smatch_expressions.c	Tue Jan  7 08:01:55 2020
@@ -85,6 +85,8 @@
 
 struct expression *deref_expression(struct expression *expr)
 {
+	if (expr->type == EXPR_BINOP)
+		expr = preop_expression(expr, '(');
 	return preop_expression(expr, '*');
 }
 
@@ -162,6 +164,17 @@
 	return ret;
 }
 
+struct expression *call_expression(struct expression *fn, struct expression_list *args)
+{
+	struct expression *expr;
+
+	expr = alloc_tmp_expression(fn->pos, EXPR_CALL);
+	expr->fn = fn;
+	expr->args = args;
+
+	return expr;
+}
+
 static struct expression *get_expression_from_base_and_str(struct expression *base, const char *addition)
 {
 	struct expression *ret = NULL;
